

document.addEventListener('DOMContentLoaded', () => {

	//var turbineCount = "@ViewBag.TurbineCount";
	//var turbineParameterCount = "@ViewBag.TurbineParameterCount";
	var circularGauge = new ej.circulargauge.CircularGauge({});
	if (turbineCount > 0) {
		//Sayfa ilk yüklendiğinde Veri Kayıt Tab için veri çekme metodunu ve interval için metodu çağırıyor.
		setIntervalValue();
		//GetCurrentData();
		GetDataForRealTimeTab();
		// #region Veri Kayıt Tab Sayfasının Metodları ve Değişkenleri
		var dataChangeStatus = 1;
		var currentInterval;
		
		
		function GetCurrentData() {  // Veritabanından en son kaydı getirir.
			
			$.ajax({
				type: "POST",
				url: "/Home/GetCurrentDataToAjax",
				data: {
					"santral": currentSantral
				},
				dataType: "json",
				success: function (jsonData) {
					currentDataList = jsonData.data;    // This is the JArray
					var message = jsonData.message; // This is the string message
					if (message.startsWith("Hata")) {
						$('#showReturnMessageText').text(message);
						$('#showReturnMessage').removeClass('alert-warning d-none').addClass('alert-danger');
					}
					else if (message.startsWith("Kayıt")) {
						$('#showReturnMessageText').text(message);
						$('#showReturnMessage').removeClass('alert-danger d-none').addClass('alert-warning');
					}
					else {
						$('#updateDate').text(message);
						const $tableBody = $('#returnDataTable tbody');
						// Clear existing rows (optional)
						$tableBody.empty();
						// $("#TurbinNumberForGraph").prop('max',row);
						for (let i = 0; i < turbineCount; i++) {
							//region değişken tanımlamaları
							let counter = i + 1;
							let time = currentDataList[0];
							let activePowerValue = currentDataList[turbineParameterCount * i + 2];
							let windSpeedValue = currentDataList[turbineParameterCount * i + 3];
							let windDirectionValue = currentDataList[turbineParameterCount * i + 4];
							let turbineStatusValue = currentDataList[turbineParameterCount * i + 5];
							//endregion

							//region Veri Kayıt Tab bölümünde  cihazdan gelen son kaydın kullanıcılara gösterilmesi
							const row = $('<tr class="text-center">');
							row.append($('<td>').text("Türbin " + counter)); //Türbin Numarası
							row.append($('<td>').text(time));//time
							row.append($('<td>').text(activePowerValue));//power
							row.append($('<td>').text(windSpeedValue));//WindSpeed
							row.append($('<td>').text(windDirectionValue));//windDirection
							row.append($('<td>').text(turbineStatusValue));//Status
							$tableBody.append(row);
							//endregion
						}
					}
				},
				failure: function (jsonData) {
					var message = jsonData.message; // This is the string message
					alert(message);
				}
			});
			GetDataForRealTimeTab();
		}
		function DownloadDataByDate() { // Seçilen tarihler arası veritabanından  tüm verileri excel dosyası olarak getirir.
			let beginDate = $("#beginDate").val();
			let endDate = $("#endDate").val();
			//alert(beginDate);
			let limitDate = new Date(beginDate);
			limitDate.setDate(limitDate.getDate() + 90);
			// alert(limitDate);
			if (limitDate < new Date(endDate)) {
				let modalIcon = '<i class="bi bi-exclamation-square"></i>';
				let modalTitle = "Uyarı: Tarih Seçimi Geçersiz! ";
				let modalBody = "Başlangıç Tarihi ile Bitiş Tarihi Arasında En Fazla 90 Gün Seçimi Yapılabilir!";
				setModalMessage(modalIcon, modalTitle, modalBody);
			}
			else if (new Date(beginDate) > new Date(endDate)) {
				let modalIcon = '<i class="bi bi-exclamation-square"></i>';
				let modalTitle = "Uyarı: Tarih Seçimi Geçersiz! ";
				let modalBody = "Başlangıç Tarihi Bitiiş Tarihinden Büyük Olamaz!";
				setModalMessage(modalIcon, modalTitle, modalBody);
			}
			else if (beginDate == "" || endDate == "") {
				let modalIcon = '<i class="bi bi-exclamation-square"></i>';
				let modalTitle = "Uyarı: Tarih Seçimi Geçersiz! ";
				let modalBody = "Başlangıç Tarihi veya Bitiş Tarihi Boş Olamaz!";
				setModalMessage(modalIcon, modalTitle, modalBody);
			}
			else {
				$('#DownloadDataByDate').removeClass('btn-primary').addClass('btn-warning');
				$('#DownloadDataByDate').text('Rapor Oluşturuluyor');
				$.ajax({
					url: "/Home/DownloadDataByDate",
					data: {
						"santral": currentSantral,
						"plantID": plantID,
						"turbinCount": turbineCount,
						"turbinParameterCount": turbineParameterCount,
						"beginDate": beginDate,
						"endDate": endDate
					},
					type: 'POST',
					success: function (response) {
						$('#DownloadDataByDate').removeClass('btn-warning').addClass('btn-primary');
						$('#DownloadDataByDate').text('Tarihe Göre Verileri Getir');
						if (response.message.startsWith("Hata")) {
							$('#showReturnMessageText').text(response.message);
							$('#showReturnMessage').removeClass('alert-warning d-none').addClass('alert-danger');
						}
						else if (response.message.startsWith("Kayıt")) {
							$('#showReturnMessageText').text(response.message);
							$('#showReturnMessage').removeClass('alert-danger d-none').addClass('alert-warning');
						}
						else {
							var byteCharacters = atob(response.fileData);
							var byteArrays = [];
							for (var offset = 0; offset < byteCharacters.length; offset += 1024) {
								var slice = byteCharacters.slice(offset, offset + 1024);
								var byteNumbers = new Array(slice.length);
								for (var i = 0; i < slice.length; i++) {
									byteNumbers[i] = slice.charCodeAt(i);
								}
								byteArrays.push(new Uint8Array(byteNumbers));
							}
							// Create the Blob from the byte array
							var blob = new Blob(byteArrays, { type: 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet' });
							// Create a link element to trigger the download
							var link = document.createElement('a');
							link.href = URL.createObjectURL(blob);
							link.download = response.fileName; // Set the downloaded file's name
							document.body.appendChild(link); // Append the link to the body
							link.click(); // Trigger the download
							document.body.removeChild(link); // Remove the link after the download
							$("#LastFileTime").val(response.time);
							$("#DownloadedFileName").val(response.fileName);

						}
					},
					error: function () {
						let modalIcon = '<i class="bi bi-exclamation-square"></i>';
						let modalTitle = "Hata: Dosya Oluşturluamadı!";
						let modalBody = "Rapor Dosyası Oluşturulurken Bir Hata Meydana Geldi!";
						setModalMessage(modalIcon, modalTitle, modalBody);
					}
				});
			}
		}
		function StartStopBtnClick() {// Veri Kayıt Tab Sayfasında Güncel Son Kaydı Getirmeyi Start - Stop Butonu ile durdurur ya da başlatır.
			if (dataChangeStatus == 1) {
				$("#StartStopBtn").html('START');
				$('#StartStopBtn').removeClass('btn-danger').addClass('btn-success');
				dataChangeStatus = 0;
				clearInterval(currentInterval);
			}
			else {
				$("#StartStopBtn").html('STOP');
				$('#StartStopBtn').removeClass('btn-success').addClass('btn-danger');
				dataChangeStatus = 1;
				setIntervalValue();
				GetCurrentData();
			}
		}
		function setIntervalValue() {
			var interval = parseInt($('#refreshTimeNUD').val());
			if (!isNaN(interval) && interval > 0) {
				if (currentInterval) {
					clearInterval(currentInterval);
				}
			}
			else {
				$('#refreshTimeNUD').val('10');
				interval = 10;
			}
			// Set the new interval based on the user input
			currentInterval = setInterval(GetCurrentData, interval * 1000 * 60);
		} // Veri Kayıt Sayfasında Son Kaydı Getirmek için Zamanı Belirler Örnek: 10 dk' da bir
		// #endregion

		// #region Grafik Tab Sayfası Metodları ve Değişkenleri
		//var currentGraphicTabDate = "@ViewBag.CurrentDateForGraphic";
		//var currentGraphicTabTime = "@ViewBag.CurrentTimeForGraphic";
		var dataListForGraphicTab = [];
		// Sayfa ilk açıldığında veritabanında herhangi bir kayıt varsa onun tarih bilgisi
		// currentGraphicTabDate değişkenine atanıyor her hangi bir kayıt yoksa 1 gönderiliyor.
		//1 Gelmesi Santrale ait hiç kaydın olmadığını gösterir.
		if (currentGraphicTabDate != 1) {
			currentGraphicTabDate = new Date(currentGraphicTabDate);
			var graphicTabRangeInput = document.getElementById("graphicTabRangeInput");
			var currentDateInput = document.getElementById("currentDateInputForGraphicTab");
			var currentTimeLbl = document.getElementById("currentTimeLblForGraphicTab");

			function convertToTime(value) {
				// Calculate the total minutes (0-144 mapped to 0-1440 minutes)
				let totalMinutes = value * 10;

				// Get hours and minutes
				let hours = Math.floor(totalMinutes / 60);
				let minutes = totalMinutes % 60;

				// Format hours and minutes to always show 2 digits
				let formattedTime = ("0" + hours).slice(-2) + ":" + ("0" + minutes).slice(-2);
				return formattedTime;
			}
			function convertToValue(time) {
				// Split the time into hours and minutes
				let [hours, minutes] = time.split(':').map(Number);

				// Convert the hours and minutes back into total minutes (value * 10)
				let totalMinutes = (hours * 60 + minutes) / 10;

				return totalMinutes;
			}
			function getGraphicDateFormatForUser() {
				let day = ("0" + currentGraphicTabDate.getDate()).slice(-2); // Add leading zero
				let month = ("0" + (currentGraphicTabDate.getMonth() + 1)).slice(-2); // Add leading zero
				let year = currentGraphicTabDate.getFullYear();
				return day + "/" + month + "/" + year;
			}
			function getGraphicDateFormatForUs() {
				let day = ("0" + currentGraphicTabDate.getDate()).slice(-2); // Add leading zero
				let month = ("0" + (currentGraphicTabDate.getMonth() + 1)).slice(-2); // Add leading zero
				let year = currentGraphicTabDate.getFullYear();
				return year + "-" + month + "-" + day + " " + currentGraphicTabTime + ":00";
			}
			function updatecurrentTimeLbl() {
				currentGraphicTabTime = convertToTime(graphicTabRangeInput.value);
				currentTimeLbl.textContent = "Geçerli Saat: " + currentGraphicTabTime;
			}
			function GetDataForGraphicTab() //Grafik Tab Sayfasında Seçilmiş Zamana Göre Verileri Controller'dan ajaxla Getirir.
			{
				$.ajax({
					type: "GET",
					url: "/Home/GetDataToGraphicTab",
					dataType: "json",
					data: {
						"santral": currentSantral,
						"currentDate": getGraphicDateFormatForUs()
					},
					success: function (jsonData) {
						var message = jsonData.message; // This is the string message
						if (message.startsWith("Hata")) {
							$('#showReturnMessageText').text(message);
							$('#showReturnMessage').removeClass('alert-warning d-none').addClass('alert-danger');
						}
						else if (message.startsWith("Kayıt")) {
							$('#showReturnMessageText').text(message);
							$('#showReturnMessage').removeClass('alert-danger d-none').addClass('alert-warning');
							$('#graphicBody').addClass('d-none');
						}
						else {
							$('#graphicBody').removeClass('d-none');
							$('#showReturnMessage').addClass('d-none');
							dataListForGraphicTab = jsonData.data;
							setValueForGraphicTab();
						}
					},
					failure: function (jsonData) {
						var message = jsonData.message; // This is the string message
						alert(message);
					}
				});
			}
			function setValueForGraphicTab() {
				let date = getGraphicDateFormatForUs();

				let index = dataListForGraphicTab.indexOf(date);
				if (index !== -1 && dataListForGraphicTab.length > 0) {
					$('#graphicBody').removeClass('d-none');
					$('#showReturnMessage').addClass('d-none');
					for (let i = 0; i < turbineCount; i++) {
						//region değişken tanımlamaları
						let counter = i + 1;
						let activePowerValue = dataListForGraphicTab[index + turbineParameterCount * i + 2];
						let windSpeedValue = dataListForGraphicTab[index + turbineParameterCount * i + 3];
						let windDirectionValue = dataListForGraphicTab[index + turbineParameterCount * i + 4];
						windDirectionValue = windDirectionValue < 0 ? 0 : windDirectionValue;
						let turbineStatusValue = dataListForGraphicTab[index + turbineParameterCount * i + 5];
						//endregion

						//region Grafik Tab bölümünde  cihazdan gelen son kaydın kullanıcılara gösterilmesi
						$("#TurbineStatus" + counter).text('T' + counter);
						if (turbineStatusValue == 0) {
							$("#TurbineStatus" + counter).css({
								'background-color': '#e60505'
							});
						}
						else {
							$("#TurbineStatus" + counter).css({
								'background-color': '#036503'
							});
						}
						$('#WindSpeed' + counter).empty();
						let WindSpeedText = $("#WindSpeed" + counter);
						WindSpeedText.html('<b class="redTextColor">' + windSpeedValue + '</b>  (m/s)');
						$("#WindSpeed" + counter).append(WindSpeedText);
						let percentWinddSpeedValue = (windSpeedValue * 100) / 25;
						$('#WindSpeedProgress' + counter).css('width', percentWinddSpeedValue + '%');



						$('#ActivePower' + counter).empty();
						let ActivePowerText = $("#ActivePower" + counter);
						ActivePowerText.html('<b class="redTextColor">' + activePowerValue + '</b>  (kW)');
						$("#ActivePower" + counter).append(ActivePowerText);
						let percentActivePowerValue = (activePowerValue * 100) / 3500;
						$('#ActivePowerProgress' + counter).css('width', percentActivePowerValue + '%');


						$("#WindDirectionValue" + counter).text(windDirectionValue + " (°)");
						var gaugeInstance = document.getElementById('WindDirectionGauge' + counter).ej2_instances[0];
						var pointer = gaugeInstance.axes[0].pointers[0];
						if (pointer.value !== windDirectionValue) {
							pointer.startAngle = pointer.value;
							pointer.value = windDirectionValue;  // Update the pointer value dynamically
							//gaugeInstance.refresh();
						}
						// #endregion
					}
				} else {
					let compareDate = getGraphicDateFormatForUs().split(" ")[0];
					if (dataListForGraphicTab.length == 0 || (dataListForGraphicTab[0].indexOf(compareDate) !== -1)) {
						$('#showReturnMessageText').text('Seçilen Tarihte Kayıt Bulunamadı!');
						$('#showReturnMessage').removeClass('alert-danger d-none').addClass('alert-warning');
						$('#graphicBody').addClass('d-none');
					}
				}
			} //Seçilen saate göre veri dizisinde arama yapar ve verileri arayüze yerleştirir.

			// #region Grafik Tab Sayfası için Initial
			graphicTabRangeInput.value = convertToValue(currentGraphicTabTime);
			currentTimeLbl.textContent = "Geçerli Saat: " + currentGraphicTabTime;
			convertToValue(currentGraphicTabTime);
			currentDateInput.value = getGraphicDateFormatForUs().split(" ")[0];
			GetDataForGraphicTab();
			for (let i = 0; i < turbineCount; i++) {
				let counter = i + 1;
				circularGauge = new ej.circulargauge.CircularGauge({
					background: 'transparent',
					width: '80px',
					height: '80px',
					axes: [{
						radius: '100%',
						startAngle: 0,
						endAngle: 360,
						animation: { enable: false },  // Disable animation here
						majorTicks: {
							width: 0,
							interval: 0,
							color: '#000000',
							showLabels: false
						},
						minorTicks: {
							width: 0,
							interval: 0
						},
						minimum: 0,
						maximum: 360,
						pointers: [{
							type: 'Marker',
							value: 0, // Dynamic wind direction value
							markerShape: 'Triangle',
							radius: '60%',
							border: { width: 2, color: 'black' },
							offset: 0,
							color: '#ff0000',
							markerHeight: 15,
							markerWidth: 15
						}],
						ranges: [{
							start: 0,
							end: 360,
							radius: '100%',
							color: '#e6e6e6',
							startWidth: 8,
							endWidth: 8
						}],
						annotations: [
							{
								content: 'N',
								angle: 0,
								radius: '80%',
								zIndex: '1',
								textStyle: { size: '12px', color: '#000000' }
							},
							{
								content: 'E',
								angle: 90,
								radius: '80%',
								zIndex: '1',
								textStyle: { size: '12px', color: '#000000' }
							},
							{
								content: 'S',
								angle: 180,
								radius: '80%',
								zIndex: '1',
								textStyle: { size: '12px', color: '#000000' }
							},
							{
								content: 'W',
								angle: 270,
								radius: '80%',
								zIndex: '1',
								textStyle: { size: '12px', color: '#000000' }
							}
						]
					}]
				}).appendTo('#WindDirectionGauge' + counter); // Append the CircularGauge to the created container
			}
			// #endregion
			graphicTabRangeInput.addEventListener("input", function () {
				currentGraphicTabTime = convertToTime(graphicTabRangeInput.value);
				currentTimeLbl.textContent = "Geçerli Saat: " + currentGraphicTabTime;
				setValueForGraphicTab();
			});
			currentDateInput.addEventListener('change', function () {
				currentGraphicTabDate = new Date(currentDateInput.value)
				graphicTabRangeInput.value = 0;
				updatecurrentTimeLbl();
				GetDataForGraphicTab();
			});
			prevDayBtn.addEventListener("click", function () {
				currentGraphicTabDate.setDate(currentGraphicTabDate.getDate() - 1);
				currentDateInput.value = getGraphicDateFormatForUs().split(" ")[0];
				graphicTabRangeInput.value = 0;
				updatecurrentTimeLbl();
				GetDataForGraphicTab();
			});
			nextDayBtn.addEventListener("click", function () {
				currentGraphicTabDate.setDate(currentGraphicTabDate.getDate() + 1);
				currentDateInput.value = getGraphicDateFormatForUs().split(" ")[0];
				graphicTabRangeInput.value = 0;// Reset 00:00
				updatecurrentTimeLbl();
				GetDataForGraphicTab()
			});
			prevWeekBtn.addEventListener("click", function () {
				currentGraphicTabDate.setDate(currentGraphicTabDate.getDate() - 7);
				currentDateInput.value = getGraphicDateFormatForUs().split(" ")[0];
				graphicTabRangeInput.value = 0;// Reset 00:00
				updatecurrentTimeLbl();
				GetDataForGraphicTab()
			});
			nextWeekBtn.addEventListener("click", function () {
				currentGraphicTabDate.setDate(currentGraphicTabDate.getDate() + 7);
				currentDateInput.value = getGraphicDateFormatForUs().split(" ")[0];
				graphicTabRangeInput.value = 0;// Reset 00:00
				updatecurrentTimeLbl();
				GetDataForGraphicTab()
			});
		}
		// #endregion

		// #region Trend Tab Sayfası Metodları ve Değişkenleri
		var today = new Date();
		var year = today.getFullYear();
		var month = ('0' + (today.getMonth() + 1)).slice(-2); // Add leading zero if needed
		var day = ('0' + today.getDate()).slice(-2); // Add leading zero if needed
		var hours = ('0' + today.getHours()).slice(-2); // Add leading zero if needed
		var minutes = ('0' + today.getMinutes()).slice(-2); // Add leading zero if needed
		var datetime = year + '-' + month + '-' + day;
		var selectedTrendOption = 1;
		const TrendDiv = document.getElementById("Trend-tab");
		const turbineParameterClose = document.getElementById("TurbineParameterClose");
		const chooseAllBtn = document.getElementById("chooseAllBtn");
		const leaveAllBtn = document.getElementById("leaveAllBtn");
		const chooseAllPowerBtn = document.getElementById("chooseAllPowerBtn");
		const chooseAllWindSpeedBtn = document.getElementById("chooseAllWindSpeedBtn");
		const chooseAllWindDirectionBtn = document.getElementById("chooseAllWindDirectionBtn");
		var queryParameterStr = "";
		var groupedItems = {
			P: [],
			WS: [],
			WD: []
		};
		function setTrendOption(eventSource) {
			if (eventSource == "click") {
				$('#TrendOption').val(1);
				$('#TrendCharts').addClass('d-none');
			}
			selectedTrendOption = document.getElementById('TrendOption').value;
			if (selectedTrendOption == 1) {
				$('#beginDateTrend').attr('type', 'date');
				$("#beginDateTrend").val(datetime);
				$("#endDateTrend").val(datetime);
				$('#EndDateTrendDiv').addClass('d-none');
				$("#BeginDateTrendLabel").html("<b>Günlük Rapor Tarihi</b>");
			}
			else if (selectedTrendOption == 2) {
				$('#EndDateTrendDiv').addClass('d-none');
				$("#BeginDateTrendLabel").html("<b>Aylık Rapor Tarihi</b>");
				$('#beginDateTrend').attr('type', 'month');
				$('#beginDateTrend').val(year + "-" + month);
			}
			else {
				$('#beginDateTrend').attr('type', 'date');
				$("#beginDateTrend").val(datetime);
				$("#endDateTrend").val(datetime);
				$('#EndDateTrendDiv').removeClass('d-none');
				$("#BeginDateTrendLabel").html("<b>Başlangıç Tarihi</b>");
			}
		}
		function GetDataForTrendTab() {
			let beginDate;
			let endDate;
			beginDate = $("#beginDateTrend").val();
			endDate = $("#endDateTrend").val();
			if (selectedTrendOption == 3 && new Date(beginDate) > new Date(endDate)) {
				let modalIcon = '<i class="bi bi-exclamation-square"></i>';
				let modalTitle = "Uyarı: Tarih Seçimi Geçersiz! ";
				let modalBody = "Başlangıç Tarihi Bitiiş Tarihinden Büyük Olamaz!";
				setModalMessage(modalIcon, modalTitle, modalBody);
			}
			else if (beginDate == "" || endDate == "") {
				let modalIcon = '<i class="bi bi-exclamation-square"></i>';
				let modalTitle = "Uyarı: Tarih Seçimi Geçersiz! ";
				let modalBody = "Başlangıç Tarihi veya Bitiş Tarihi Boş Olamaz!";
				setModalMessage(modalIcon, modalTitle, modalBody);
			}
			else if (Object.values(groupedItems.P).length == 0 && Object.values(groupedItems.WS).length == 0 && Object.values(groupedItems.WD).length == 0) {
				let modalIcon = '<i class="bi bi-exclamation-square"></i>';
				let modalTitle = "Uyarı: Parametre Seçimi Geçersiz! ";
				let modalBody = "Türbinlerin Parametrelerinin Seçimi Boş Olamaz!";
				setModalMessage(modalIcon, modalTitle, modalBody);
			}
			else {
				$('#GetDataForTrendTabBtn').removeClass('btn-primary').addClass('btn-warning');
				$('#GetDataForTrendTabBtn').text('Seçim Uygulanıyor');
				$.ajax({
					type: "GET",
					url: "/Home/GetDataToTrendTab",
					dataType: "json",
					data: {
						"santral": currentSantral,
						"beginDate": beginDate,
						"endDate": endDate,
						"selectedTrendOption": selectedTrendOption,
						"queryParameterStr": queryParameterStr
					},
					success: function (jsonData) {
						var message = jsonData.message; // This is the string message
						if (message.startsWith("Hata")) {
							$('#showReturnMessageText').text(message);
							$('#showReturnMessage').removeClass('alert-warning d-none').addClass('alert-danger');
							$('#TrendCharts').addClass('d-none');
						}
						else if (message.startsWith("Kayıt")) {
							$('#showReturnMessageText').text(message);
							$('#showReturnMessage').removeClass('alert-danger d-none').addClass('alert-warning');
							$('#TrendCharts').addClass('d-none');
						}
						else {
							$('#showReturnMessage').addClass('d-none');
							$('#TrendCharts').removeClass('d-none');
							$('#ActivePowerTrendChart').empty();
							$('#WindSpeedTrendChart').empty();
							$('#WindDirectionTrendChart').empty();

							let gotData = jsonData.data;
							let parameterCount = 1 + Object.values(groupedItems.P).length + Object.values(groupedItems.WS).length + Object.values(groupedItems.WD).length;
							let loopCount = gotData.length / parameterCount;
							let pCount = Object.values(groupedItems.P).length;
							let wsCount = Object.values(groupedItems.WS).length;
							let wdCount = Object.values(groupedItems.WD).length;
							let timeList = [];
							groupedItems.P.forEach(item => {
							});
							groupedItems.WS.forEach(item => {
							});
							groupedItems.WD.forEach(item => {
							});
							for (let i = 0; i < loopCount; i++) {
								timeList.push(gotData[(parameterCount * i)]);
								for (let p = 0; p < pCount; p++) {
									groupedItems.P[p].data.push(gotData[(parameterCount * i) + 1 + p]);

								}
								for (let ws = 0; ws < wsCount; ws++) {
									groupedItems.WS[ws].data.push(gotData[(parameterCount * i) + 1 + pCount + ws]);

								}
								for (let wd = 0; wd < wdCount; wd++) {

									groupedItems.WD[wd].data.push(gotData[(parameterCount * i) + 1 + pCount + wsCount + wd]);
								}
							}


							let TrendChartValueType;
							let TrendChartIntervalType;
							let TrendChartIntervalValue;
							let TrendChartLabelFormat;
							let XAxislabelRotation;

							var averageActivePowerTimeList = groupedItems.P.map(item => {
								// Create an array of objects for each series, where each object has x and y
								var seriesData = item.data.map((value, index) => ({
									x: timeList[index], // Time from TimeArray
									y: parseFloat(value)  // Convert string values to numbers for charting
								}));

								return {
									dataSource: seriesData,
									name: item.usLbl  // Use userLbl for parameter name in chart
								};
							});

							var averageWindSpeedTimeList = groupedItems.WS.map(item => {
								// Create an array of objects for each series, where each object has x and y
								var seriesData = item.data.map((value, index) => ({
									x: timeList[index], // Time from TimeArray
									y: parseFloat(value)  // Convert string values to numbers for charting
								}));

								return {
									dataSource: seriesData,
									name: item.usLbl  // Use userLbl for parameter name in chart
								};
							});

							var averageWindDirectionTimeList = groupedItems.WD.map(item => {
								// Create an array of objects for each series, where each object has x and y
								var seriesData = item.data.map((value, index) => ({
									x: timeList[index], // Time from TimeArray
									y: parseFloat(value)  // Convert string values to numbers for charting
								}));

								return {
									dataSource: seriesData,
									name: item.usLbl  // Use userLbl for parameter name in chart
								};
							});

							if (selectedTrendOption == 1) {
								TrendChartValueType = 'Category';
								TrendChartIntervalType = 'Hours';
								TrendChartIntervalValue = 1;
								TrendChartLabelFormat = 'HH:mm';
								XAxislabelRotation = 60;
							}
							if (selectedTrendOption == 2) {
								TrendChartValueType = 'Category';
								TrendChartIntervalType = 'dd-MMM-yyyy';
								TrendChartIntervalValue = 1;
								TrendChartLabelFormat = 'Days';
								XAxislabelRotation = timeList.length > 10 ? 60 : 0;
							}
							if (selectedTrendOption == 3) {

								TrendChartValueType = 'Category';
								TrendChartIntervalType = '';
								if (timeList.length > 24) TrendChartIntervalValue = 1;
								if (timeList.length > 60) TrendChartIntervalValue = 7;
								TrendChartLabelFormat = '';
								XAxislabelRotation = 60;
							}
							if (pCount != 0) {
								let ActivePowerTrendChart = new ej.charts.Chart({
									// Define the chart title
									// title: 'Line Chart Example',
									// Define the primary X and Y axes
									primaryXAxis: {
										title: 'Zaman',
										valueType: TrendChartValueType,  // Use 'Category' for custom values like hours
										intervalType: TrendChartIntervalType,  // Interval type: hour-based intervals
										interval: TrendChartIntervalValue,  // 1-hour interval (adjust as needed)
										labelFormat: TrendChartLabelFormat,  // Format the label to show hour and minute (24-hour format)
										labelRotation: XAxislabelRotation
									},
									primaryYAxis: {
										title: 'Aktif Güç (kW)',
										minimum: -200,           // Set the minimum value for Y axis
										maximum: 4500,          // Set the maximum value for Y axis
										interval: 500,         // Set step interval for Y axis labels
										labelFormat: '{value} (kW)'  // Label format to show the value with the unit

									},
									zoomSettings: {
										//enableMouseWheelZooming: true,  // Fareyle zoom yapmayı etkinleştirir
										enablePinchZooming: true,  // Mobilde parmakla zoom yapmayı etkinleştirir
										mode: 'XY',  // Hem X hem de Y eksenlerinde zoom yapılmasını sağlar
										enableSelectionZooming: true,  // Seçimle zoom yapılmasını sağlar
										enableZoomOnMouseWheel: true,  // Fare tekerleği ile zoom yapmayı sağlar
										animationDuration: 500  // Zoom animasyonu süresi
									},
									// Define the series (line)
									series: averageActivePowerTimeList.map(data => ({
										type: 'Line', // You can choose other chart types like Column, Area, etc.
										dataSource: data.dataSource,
										xName: 'x',
										yName: 'y',
										type: 'Line',
										name: data.name
									})),
									// series: [{
									// 	dataSource: averageActivePowerTimeList,
									// 	xName: 'x',   // x-values
									// 	yName: 'y',   // y-values
									// 	type: 'Column', // Define the type of chart (Line Chart)
									// 	name: 'Aktif Güç (kW)', // Label for the line
									// 	marker: { visible: true } // Optionally add markers at each data point
									// }],
									tooltip: {
										enable: true,  // Enable the tooltip
										format: 'Zaman: ${point.x} <br/> Aktif Güç: ${point.y}'  // Tooltip format to show x and y values
									},
									// Add a legend
									legendSettings: {
										visible: true
									}
								});
								// Append the chart to the container
								ActivePowerTrendChart.appendTo('#ActivePowerTrendChart');
								ActivePowerTrendChart.refresh();
								$("#ActivePowerContent").removeClass("d-none");
							}
							else {
								$("#ActivePowerContent").addClass("d-none");
							}

							if (wsCount != 0) {
								let WindSpeedTrendChart = new ej.charts.Chart({
									// Define the chart title
									// title: 'Line Chart Example',
									// Define the primary X and Y axes
									primaryXAxis: {
										title: 'Zaman',
										valueType: TrendChartValueType,  // Use 'Category' for custom values like hours
										intervalType: TrendChartIntervalType,  // Interval type: hour-based intervals
										interval: TrendChartIntervalValue,  // 1-hour interval (adjust as needed)
										labelFormat: TrendChartLabelFormat,  // Format the label to show hour and minute (24-hour format)
										labelRotation: XAxislabelRotation
									},
									primaryYAxis: {
										title: 'Rüzgar Hızı (m/s)',
										minimum: 0,           // Set the minimum value for Y axis
										maximum: 27,          // Set the maximum value for Y axis
										interval: 3,         // Set step interval for Y axis labels
										labelFormat: '{value} (m/s)',  // Label format to show the value with the unit

									},
									zoomSettings: {
										//enableMouseWheelZooming: true,  // Fareyle zoom yapmayı etkinleştirir
										enablePinchZooming: true,  // Mobilde parmakla zoom yapmayı etkinleştirir
										mode: 'XY',  // Hem X hem de Y eksenlerinde zoom yapılmasını sağlar
										enableSelectionZooming: true,  // Seçimle zoom yapılmasını sağlar
										enableZoomOnMouseWheel: true,  // Fare tekerleği ile zoom yapmayı sağlar
										animationDuration: 500  // Zoom animasyonu süresi
									},
									// Define the series (line)
									series: averageWindSpeedTimeList.map(data => ({
										type: 'Line', // You can choose other chart types like Column, Area, etc.
										dataSource: data.dataSource,
										xName: 'x',
										yName: 'y',
										type: 'Line',
										name: data.name
									})),
									// series: [{
									// 	dataSource: averageWindSpeedTimeList,
									// 	xName: 'x',   // x-values
									// 	yName: 'y',   // y-values
									// 	type: 'Line', // Define the type of chart (Line Chart)
									// 	name: 'Rüzgar Hızı (m/s)', // Label for the line
									// 	marker: { visible: true } // Optionally add markers at each data point
									// }],
									tooltip: {
										enable: true,  // Enable the tooltip
										format: 'Zaman: ${point.x} <br/> Rüzgar Hızı: ${point.y}'  // Tooltip format to show x and y values
									},
									// Add a legend
									legendSettings: {
										visible: true
									}
								});

								// Append the chart to the container
								WindSpeedTrendChart.appendTo('#WindSpeedTrendChart');
								WindSpeedTrendChart.refresh();
								$("#WindSpeedTrendContent").removeClass("d-none");
							}
							else {
								$("#WindSpeedTrendContent").addClass("d-none");
							}

							if (wdCount != 0) {
								let WindDirectionTrendChart = new ej.charts.Chart({
									// Define the chart title
									// title: 'Line Chart Example',
									// Define the primary X and Y axes
									primaryXAxis: {
										title: 'Zaman',
										valueType: TrendChartValueType,  // Use 'Category' for custom values like hours
										intervalType: TrendChartIntervalType,  // Interval type: hour-based intervals
										interval: TrendChartIntervalValue,  // 1-hour interval (adjust as needed)
										labelFormat: TrendChartLabelFormat,  // Format the label to show hour and minute (24-hour format)
										labelRotation: XAxislabelRotation
									},
									primaryYAxis: {
										title: 'Rüzgar Yönü (°)',
										minimum: 0,           // Set the minimum value for Y axis
										maximum: 360,          // Set the maximum value for Y axis
										interval: 20,         // Set step interval for Y axis labels
										labelFormat: '{value} (°)',  // Label format to show the value with the unit

									},
									zoomSettings: {
										//enableMouseWheelZooming: true,  // Fareyle zoom yapmayı etkinleştirir
										enablePinchZooming: true,  // Mobilde parmakla zoom yapmayı etkinleştirir
										mode: 'XY',  // Hem X hem de Y eksenlerinde zoom yapılmasını sağlar
										enableSelectionZooming: true,  // Seçimle zoom yapılmasını sağlar
										enableZoomOnMouseWheel: true,  // Fare tekerleği ile zoom yapmayı sağlar
										animationDuration: 500  // Zoom animasyonu süresi
									},
									// Define the series (line)
									// series: [{
									// 	dataSource: averageWindDirectionTimeList,
									// 	xName: 'x',   // x-values
									// 	yName: 'y',   // y-values
									// 	type: 'Area', // Define the type of chart (Line Chart)
									// 	name: 'Rüzgar Yönü(°)', // Label for the line
									// 	marker: { visible: true }, // Optionally add markers at each data point
									// 	opacity: 0.4  // Set opacity of the line (slightly transparent)
									// }],
									series: averageWindDirectionTimeList.map(data => ({
										type: 'Line', // You can choose other chart types like Column, Area, etc.
										dataSource: data.dataSource,
										xName: 'x',
										yName: 'y',
										type: 'Line',
										name: data.name
									})),
									tooltip: {
										enable: true,  // Enable the tooltip
										format: 'Zaman: ${point.x} <br/> Rüzgar Yönü: ${point.y}'  // Tooltip format to show x and y values
									},
									// Add a legend
									legendSettings: {
										visible: true
									}
								});
								// Append the chart to the container
								WindDirectionTrendChart.appendTo('#WindDirectionTrendChart');
								WindDirectionTrendChart.refresh();
								$("#WindDirectionTrendContent").removeClass("d-none");
							} else {
								$("#WindDirectionTrendContent").addClass("d-none");
							}
						}
						$('#GetDataForTrendTabBtn').addClass('btn-primary').removeClass('btn-warning');
						$('#GetDataForTrendTabBtn').text('Seçimi Uygula');
					},
					failure: function (jsonData) {
						var message = jsonData.message; // This is the string message
						alert(message);
						$('#GetDataForTrendTabBtn').addClass('btn-primary').removeClass('btn-warning');
						$('#GetDataForTrendTabBtn').text('Seçimi Uygula');
					}

				});

			}

		}
		TrendDiv.addEventListener("click", function () {
			$('#TurbineParameterSelectedText').text('');
			leaveAllBtn.click();
			setTrendOption("click");
		});
		TrendOption.addEventListener("change", function () {
			setTrendOption("change");
		});
		turbineParameterClose.addEventListener("click", function () {

			$('#TrendModal').modal('hide');

			var checkedItems = $("#TurbineParameterChoose input[type='checkbox']:checked").map(function () {
				var checkboxId = $(this).attr("id");  // Get the checkbox id
				var secondChar = checkboxId.charAt(1); // Get the second character of the id
				var lblText = $("label[for='" + checkboxId + "']").text();  // Get the label text for the checkbox
				var userLblText = " Türbin " + secondChar + " " + lblText;
				var usLblText = " Türbin " + secondChar;
				return { id: checkboxId, userLbl: userLblText, usLbl: usLblText, data: [] };  // Return id, secondChar, and label as an object
			}).get();
			var TurbineParameterSelectedText = checkedItems.map(function (item) {
				return item.userLbl;
			});

			$('#TurbineParameterSelectedText').html("");
			if (TurbineParameterSelectedText.length > 0) $('#TurbineParameterSelectedText').html("Seçilenler:" + TurbineParameterSelectedText);

			groupedItems = checkedItems.reduce(function (groups, item) {
				if (item.id.includes('_P')) {
					groups.P.push(item); // Push to the _P group
				} else if (item.id.includes('_WS')) {
					groups.WS.push(item); // Push to the _WD group
				}
				else if (item.id.includes('_WD')) {
					groups.WD.push(item); // Push to the _WD group
				}
				return groups;
			}, { P: [], WS: [], WD: [] }); // Initialize empty groups for _P and _WD

			queryParameterStr = Object.values(groupedItems)
				.flat()   // Flatten the arrays (in case there are nested arrays)
				.map(item => item.id)  // Extract the 'id' property from each object
				.filter(item => item !== undefined && item !== null)  // Remove any undefined or null values
				.join(',');  // Join all elements into one string
		});
		chooseAllBtn.addEventListener("click", function () {
			$('#TurbineParameterChoose input[type="checkbox"]').prop('checked', true);
		});
		leaveAllBtn.addEventListener("click", function () {
			$('#TurbineParameterChoose input[type="checkbox"]').prop('checked', false);
			$('#chooseAllPowerBtn').prop('checked', false);
			$('#chooseAllWindSpeedBtn').prop('checked', false);
			$('#chooseAllWindDirectionBtn').prop('checked', false);
			groupedItems = {
				P: [],
				WS: [],
				WD: []
			};
		});
		chooseAllPowerBtn.addEventListener("click", function () {
			$('#TurbineParameterChoose input[type="checkbox"][id*="_P"]').prop('checked', chooseAllPowerBtn.checked);
		});
		chooseAllWindSpeedBtn.addEventListener("click", function () {
			$('#TurbineParameterChoose input[type="checkbox"][id*="_WS"]').prop('checked', chooseAllWindSpeedBtn.checked);
		});
		chooseAllWindDirectionBtn.addEventListener("click", function () {
			$('#TurbineParameterChoose input[type="checkbox"][id*="_WD"]').prop('checked', chooseAllWindDirectionBtn.checked);
		});
		$("#GetDataForTrendTabBtn").on("click", function (event) {

			GetDataForTrendTab();

		});
		//  #endregion

		// #region Real Time Tab Sayfası Metodları ve Değişkenleri
		var realTimeDataState = 0; //1=Veri Var,2=Veri Yok
		var sound = document.getElementById('openSound');
		var ActivePowerRealTimeChart = new ej.charts.Chart({});
		var WindSpeedRealTimeChart = new ej.charts.Chart({});
		var WindDirectionRealTimeChart = new ej.charts.Chart({});
		var turbineParameterItems = {
			P: [],
			WS: [],
			WD: []
		};
		$("#RealTime-tab").on("click", function (event) {
			//RealTime Tab Sayfası içinde belirlenen zamanda veri getirmek için
			//GetDataForRealTimeTab();
			// $('#RealTimeContent').removeClass('d-none');
			if (realTimeDataState == 2) sound.play();
			else {
				sound.pause();
				$('#RealTimeNoRecord').addClass('d-none');
			}
			if (realTimeDataState == 1) {
				ActivePowerRealTimeChart.refresh();
				WindSpeedRealTimeChart.refresh();
				WindDirectionRealTimeChart.refresh();
			}

		});
		function GetDataForRealTimeTab() {
			let realTimeTabToday = new Date();
			let realTimeTabYear = realTimeTabToday.getFullYear();
			let realTimeTabMonth = ('0' + (realTimeTabToday.getMonth() + 1)).slice(-2); // Add leading zero if needed
			let realTimeTabDay = ('0' + realTimeTabToday.getDate()).slice(-2); // Add leading zero if needed
			let realTimeTabCurrentDate = realTimeTabYear + "-" + realTimeTabMonth + "-" + realTimeTabDay;
			//let realTimeTabCurrentDate= "2024-12-01"; //Yıl-Ay-Gün
			$.ajax({
				type: "GET",
				url: "/Home/GetDataToRealTimeTab",
				dataType: "json",
				data: {
					"santral": currentSantral,
					"realTimeTabCurrentDate": realTimeTabCurrentDate,
				},
				success: function (jsonData) {
					var message = jsonData.message; // This is the string message
					if (message.startsWith("Hata")) {
						$('#showReturnMessageText').text(message);
						$('#showReturnMessage').removeClass('alert-warning d-none').addClass('alert-danger');
						$('#RealTimeCharts').addClass('d-none');
						$('#RealTimeNoRecord').addClass('d-none');


						realTimeDataState = 3;
					}
					else if (message.startsWith("Kayıt")) {
						$('#RealTimeNoRecord').removeClass('d-none');
						realTimeDataState = 2;
					}
					else {
						realTimeDataState = 1;
						$('#showReturnMessage').addClass('d-none');
						$('#RealTimeNoRecord').addClass('d-none');
						$('#RealTimeCharts').removeClass('d-none');

						turbineParameterItems = {
							P: [],
							WS: [],
							WD: []
						};

						let gotData = jsonData.data;
						let timeList = [];
						let colCount = (turbineParameterCount * turbineCount) + 2;
						let rowCount = gotData.length / colCount;




						// Populate the arrays with distinct objects for P, WS, and WD
						for (let i = 0; i < turbineCount; i++) {
							let turbineItem = { id: 'T' + (i + 1) + 'P', usLbl: 'Türbin ' + (i + 1), data: [] };
							turbineParameterItems.P.push(turbineItem);
						}
						for (let i = 0; i < turbineCount; i++) {
							let turbineItem = { id: 'T' + (i + 1) + 'WS', usLbl: 'Türbin ' + (i + 1), data: [] };
							turbineParameterItems.WS.push(turbineItem);
						}
						for (let i = 0; i < turbineCount; i++) {
							let turbineItem = { id: 'T' + (i + 1) + 'WD', usLbl: 'Türbin ' + (i + 1), data: [] };
							turbineParameterItems.WD.push(turbineItem);
						}

						// Populating the timeList and data for P, WS, and WD
						for (let i = 0; i < rowCount; i++) {

							let time = new Date(gotData[(colCount) * i]);
							time = ('0' + time.getHours()).slice(-2) + ':' + ('0' + time.getMinutes()).slice(-2);
							timeList.push(time);  // Assuming the first column is time

							// Populate P, WS, and WD data for each turbine
							for (let k = 0; k < turbineCount; k++) {
								// Add data for P
								turbineParameterItems.P[k].data.push(gotData[(colCount * i) + (k * turbineParameterCount) + 2]);

								// Add data for WS
								turbineParameterItems.WS[k].data.push(gotData[(colCount * i) + (k * turbineParameterCount) + 3]); // Example index adjustment

								// Add data for WD
								turbineParameterItems.WD[k].data.push(gotData[(colCount * i) + (k * turbineParameterCount) + 4]); // Example index adjustment
							}
						}
						let realTimeActivePowerTimeList = turbineParameterItems.P.map(item => {
							// Create an array of objects for each series, where each object has x and y
							var seriesData = item.data.map((value, index) => ({
								x: timeList[index], // Time from TimeArray
								y: parseFloat(value)  // Convert string values to numbers for charting
							}));

							return {
								dataSource: seriesData,
								name: item.usLbl  // Use userLbl for parameter name in chart
							};
						});

						var realTimeWindSpeedTimeList = turbineParameterItems.WS.map(item => {
							// Create an array of objects for each series, where each object has x and y
							var seriesData = item.data.map((value, index) => ({
								x: timeList[index], // Time from TimeArray
								y: parseFloat(value)  // Convert string values to numbers for charting
							}));

							return {
								dataSource: seriesData,
								name: item.usLbl  // Use userLbl for parameter name in chart
							};
						});

						var realTimeWindDirectionTimeList = turbineParameterItems.WD.map(item => {
							// Create an array of objects for each series, where each object has x and y
							var seriesData = item.data.map((value, index) => ({
								x: timeList[index], // Time from TimeArray
								y: parseFloat(value)  // Convert string values to numbers for charting
							}));

							return {
								dataSource: seriesData,
								name: item.usLbl  // Use userLbl for parameter name in chart
							};
						});
						const minValueInP = getMinMaxForParameter('P').minValue;
						const maxValueInP = getMinMaxForParameter('P').maxValue;
						ActivePowerRealTimeChart = new ej.charts.Chart({
							// Define the chart title
							// title: 'Line Chart Example',
							// Define the primary X and Y axes
							width: '98%',
							primaryXAxis: {
								title: 'Zaman',
								valueType: 'Category',  // Use 'Category' for custom values like hours
								intervalType: 'Hours',  // Interval type: hour-based intervals
								interval: 2,  // 1-hour interval (adjust as needed)
								labelFormat: 'HH:mm',  // Format the label to show hour and minute (24-hour format)
								labelRotation: 60,
							},
							primaryYAxis: {
								title: 'Aktif Güç (kW)',
								minimum: minValueInP,           // Set the minimum value for Y axis
								maximum: maxValueInP,          // Set the maximum value for Y axis
								interval: 500,         // Set step interval for Y axis labels
								labelFormat: '{value} (kW)'  // Label format to show the value with the unit

							},
							zoomSettings: {
								//enableMouseWheelZooming: true,  // Fareyle zoom yapmayı etkinleştirir
								enablePinchZooming: true,  // Mobilde parmakla zoom yapmayı etkinleştirir
								mode: 'XY',  // Hem X hem de Y eksenlerinde zoom yapılmasını sağlar
								enableSelectionZooming: true,  // Seçimle zoom yapılmasını sağlar
								enableZoomOnMouseWheel: true,  // Fare tekerleği ile zoom yapmayı sağlar
								animationDuration: 500  // Zoom animasyonu süresi
							},
							// Define the series (line)
							series: realTimeActivePowerTimeList.map(data => ({
								type: 'Line', // You can choose other chart types like Column, Area, etc.
								dataSource: data.dataSource,
								xName: 'x',
								yName: 'y',
								type: 'Line',
								name: data.name
							})),
							// series: [{
							// 	dataSource: averageActivePowerTimeList,
							// 	xName: 'x',   // x-values
							// 	yName: 'y',   // y-values
							// 	type: 'Column', // Define the type of chart (Line Chart)
							// 	name: 'Aktif Güç (kW)', // Label for the line
							// 	marker: { visible: true } // Optionally add markers at each data point
							// }],
							tooltip: {
								enable: true,  // Enable the tooltip
								format: 'Zaman: ${point.x} <br/> Aktif Güç: ${point.y}'  // Tooltip format to show x and y values
							},
							// Add a legend
							legendSettings: {
								position: 'Right',
								visible: true
							},
						});
						// Append the chart to the container
						ActivePowerRealTimeChart.appendTo('#ActivePowerRealTimeChart');
						ActivePowerRealTimeChart.refresh();
						var windDirectionRealTimeTable = document.getElementById('ActivePowerRealTimeTable').getElementsByTagName('tbody')[0];

						turbineParameterItems.P.forEach(function (turbine) {
							// Get the min and max values from the data array
							// Convert all string values to numbers
							const data = turbine.data.map(value => parseFloat(value));
							const validData = data.filter(value => !isNaN(value));
							var minValue = Math.min(...validData);
							var maxValue = Math.max(...validData);
							let lastValue = validData[validData.length - 1];
							// Calculate the average value
							let sum = 0;
							for (let i = 0; i < validData.length; i++) {
								sum += validData[i];
							}
							let averageValue = sum / validData.length;

							// Create a new row
							var row = windDirectionRealTimeTable.insertRow();

							// Insert cells for Turbine ID, User Label, Min Value, Max Value
							var cell1 = row.insertCell(0);
							var cell2 = row.insertCell(1);
							var cell3 = row.insertCell(2);
							var cell4 = row.insertCell(3);
							var cell5 = row.insertCell(4);

							cell1.textContent = turbine.usLbl;
							cell2.textContent = lastValue;
							cell3.textContent = minValue;
							cell4.textContent = maxValue;
							cell5.textContent = averageValue.toFixed(2);
						});

						const minValueInWS = getMinMaxForParameter('WS').minValue;
						const maxValueInWS = getMinMaxForParameter('WS').maxValue;
						WindSpeedRealTimeChart = new ej.charts.Chart({
							// Define the chart title
							// title: 'Line Chart Example',
							// Define the primary X and Y axes
							width: '98%',
							primaryXAxis: {
								title: 'Zaman',
								valueType: 'Category',  // Use 'Category' for custom values like hours
								intervalType: 'Hours',  // Interval type: hour-based intervals
								interval: 2,  // 1-hour interval (adjust as needed)
								labelFormat: 'HH:mm',  // Format the label to show hour and minute (24-hour format)
								labelRotation: 60,
							},
							primaryYAxis: {
								title: 'Rüzgar Hızı (m/s)',
								minimum: minValueInWS,           // Set the minimum value for Y axis
								maximum: maxValueInWS,          // Set the maximum value for Y axis
								interval: 5,         // Set step interval for Y axis labels
								labelFormat: '{value} (m/s)',  // Label format to show the value with the unit

							},
							zoomSettings: {
								//enableMouseWheelZooming: true,  // Fareyle zoom yapmayı etkinleştirir
								enablePinchZooming: true,  // Mobilde parmakla zoom yapmayı etkinleştirir
								mode: 'XY',  // Hem X hem de Y eksenlerinde zoom yapılmasını sağlar
								enableSelectionZooming: true,  // Seçimle zoom yapılmasını sağlar
								enableZoomOnMouseWheel: true,  // Fare tekerleği ile zoom yapmayı sağlar
								animationDuration: 500  // Zoom animasyonu süresi
							},
							// Define the series (line)
							series: realTimeWindSpeedTimeList.map(data => ({
								type: 'Line', // You can choose other chart types like Column, Area, etc.
								dataSource: data.dataSource,
								xName: 'x',
								yName: 'y',
								type: 'Line',
								name: data.name
							})),
							// series: [{
							// 	dataSource: averageWindSpeedTimeList,
							// 	xName: 'x',   // x-values
							// 	yName: 'y',   // y-values
							// 	type: 'Line', // Define the type of chart (Line Chart)
							// 	name: 'Rüzgar Hızı (m/s)', // Label for the line
							// 	marker: { visible: true } // Optionally add markers at each data point
							// }],
							tooltip: {
								enable: true,  // Enable the tooltip
								format: 'Zaman: ${point.x} <br/> Rüzgar Hızı: ${point.y}'  // Tooltip format to show x and y values
							},
							// Add a legend
							legendSettings: {
								position: 'Right',
								visible: true
							},
						});
						// Append the chart to the container
						WindSpeedRealTimeChart.appendTo('#WindSpeedRealTimeChart');
						WindSpeedRealTimeChart.refresh();
						var windDirectionRealTimeTable = document.getElementById('WindSpeedRealTimeTable').getElementsByTagName('tbody')[0];
						$('#WindSpeedRealTimeTable').Text = '';
						turbineParameterItems.WS.forEach(function (turbine) {
							// Get the min and max values from the data array
							// Convert all string values to numbers
							const data = turbine.data.map(value => parseFloat(value));
							const validData = data.filter(value => !isNaN(value));
							var minValue = Math.min(...validData);
							var maxValue = Math.max(...validData);
							let lastValue = validData[validData.length - 1];
							// Calculate the average value
							let sum = 0;
							for (let i = 0; i < validData.length; i++) {
								sum += validData[i];
							}
							let averageValue = sum / validData.length;

							// Create a new row
							var row = windDirectionRealTimeTable.insertRow();

							// Insert cells for Turbine ID, User Label, Min Value, Max Value
							var cell1 = row.insertCell(0);
							var cell2 = row.insertCell(1);
							var cell3 = row.insertCell(2);
							var cell4 = row.insertCell(3);
							var cell5 = row.insertCell(4);

							cell1.textContent = turbine.usLbl;
							cell2.textContent = lastValue;
							cell3.textContent = minValue;
							cell4.textContent = maxValue;
							cell5.textContent = averageValue.toFixed(2);
						});

						const minValueInWD = getMinMaxForParameter('WD').minValue;
						const maxValueInWD = getMinMaxForParameter('WD').maxValue;
						WindDirectionRealTimeChart = new ej.charts.Chart({
							// Define the chart title
							// title: 'Line Chart Example',
							// Define the primary X and Y axes
							width: '98%',
							primaryXAxis: {
								title: 'Zaman',
								valueType: 'Category',  // Use 'Category' for custom values like hours
								intervalType: 'Hours',  // Interval type: hour-based intervals
								interval: 2,  // 1-hour interval (adjust as needed)
								labelFormat: 'HH:mm',  // Format the label to show hour and minute (24-hour format)
								labelRotation: 60,
							},
							primaryYAxis: {
								title: 'Rüzgar Yönü (°)',
								minimum: minValueInWD,           // Set the minimum value for Y axis
								maximum: maxValueInWD,          // Set the maximum value for Y axis
								interval: 20,         // Set step interval for Y axis labels
								labelFormat: '{value} (°)',  // Label format to show the value with the unit

							},
							zoomSettings: {
								//enableMouseWheelZooming: true,  // Fareyle zoom yapmayı etkinleştirir
								enablePinchZooming: true,  // Mobilde parmakla zoom yapmayı etkinleştirir
								mode: 'XY',  // Hem X hem de Y eksenlerinde zoom yapılmasını sağlar
								enableSelectionZooming: true,  // Seçimle zoom yapılmasını sağlar
								enableZoomOnMouseWheel: true,  // Fare tekerleği ile zoom yapmayı sağlar
								animationDuration: 500  // Zoom animasyonu süresi
							},
							// Define the series (line)
							// series: [{
							// 	dataSource: averageWindDirectionTimeList,
							// 	xName: 'x',   // x-values
							// 	yName: 'y',   // y-values
							// 	type: 'Area', // Define the type of chart (Line Chart)
							// 	name: 'Rüzgar Yönü(°)', // Label for the line
							// 	marker: { visible: true }, // Optionally add markers at each data point
							// 	opacity: 0.4  // Set opacity of the line (slightly transparent)
							// }],
							series: realTimeWindDirectionTimeList.map(data => ({
								type: 'Line', // You can choose other chart types like Column, Area, etc.
								dataSource: data.dataSource,
								xName: 'x',
								yName: 'y',
								type: 'Line',
								name: data.name
							})),
							tooltip: {
								enable: true,  // Enable the tooltip
								format: 'Zaman: ${point.x} <br/> Rüzgar Yönü: ${point.y}'  // Tooltip format to show x and y values
							},
							// Add a legend
							legendSettings: {
								position: 'Right',
								visible: true
							},
						});
						// Append the chart to the container
						WindDirectionRealTimeChart.appendTo('#WindDirectionRealTimeChart');
						WindDirectionRealTimeChart.refresh();

						var windDirectionRealTimeTable = document.getElementById('WindDirectionRealTimeTable').getElementsByTagName('tbody')[0];
						$('#WindDirectionRealTimeTable').Text = '';
						turbineParameterItems.WD.forEach(function (turbine) {
							// Get the min and max values from the data array
							// Convert all string values to numbers
							const data = turbine.data.map(value => parseFloat(value));
							const validData = data.filter(value => !isNaN(value));
							var minValue = Math.min(...validData);
							var maxValue = Math.max(...validData);
							let lastValue = validData[validData.length - 1];
							// Calculate the average value
							let sum = 0;
							for (let i = 0; i < validData.length; i++) {
								sum += validData[i];
							}
							let averageValue = sum / validData.length;

							// Create a new row
							var row = windDirectionRealTimeTable.insertRow();

							// Insert cells for Turbine ID, User Label, Min Value, Max Value
							var cell1 = row.insertCell(0);
							var cell2 = row.insertCell(1);
							var cell3 = row.insertCell(2);
							var cell4 = row.insertCell(3);
							var cell5 = row.insertCell(4);

							cell1.textContent = turbine.usLbl;
							cell2.textContent = lastValue;
							cell3.textContent = minValue;
							cell4.textContent = maxValue;
							cell5.textContent = averageValue.toFixed(2);
						});

					}
				},
				failure: function (jsonData) {
					var message = jsonData.message; // This is the string message
					alert(message);
				}
			});
			// $('#RealTimeContent').removeClass('d-none');

		}
		function getMinMaxForParameter(parameterType) {
			// Check if the selected parameter type exists in turbineParameterItems
			if (!turbineParameterItems[parameterType]) {
				console.log('Invalid parameter type. Please choose from P, WS, or WD.');
				return;
			}

			// Get the turbines for the selected parameter
			const turbines = turbineParameterItems[parameterType];

			let globalMinValue = Infinity;
			let globalMaxValue = -Infinity;
			let minTurbine = null;
			let maxTurbine = null;

			// Loop through each turbine in the selected parameter
			turbines.forEach(turbine => {
				// Get the minimum and maximum value for the current turbine's data array
				const turbineMin = Math.min(...turbine.data);
				const turbineMax = Math.max(...turbine.data);

				// Check if this turbine has the new minimum value
				if (turbineMin < globalMinValue) {
					globalMinValue = turbineMin;
					minTurbine = turbine;  // Store the turbine object with the min value
				}

				// Check if this turbine has the new maximum value
				if (turbineMax > globalMaxValue) {
					globalMaxValue = turbineMax;
					maxTurbine = turbine;  // Store the turbine object with the max value
				}
			});

			// Return the result with the min/max values, id, and usLbl
			return {
				minValue: globalMinValue,
				minTurbineId: minTurbine ? minTurbine.id : null,
				minTurbineUsLbl: minTurbine ? minTurbine.usLbl : null,
				maxValue: globalMaxValue,
				maxTurbineId: maxTurbine ? maxTurbine.id : null,
				maxTurbineUsLbl: maxTurbine ? maxTurbine.usLbl : null
			};
		}
		$('#RealTime-tab').on('hidden.bs.tab', function () {
			// $('#RealTimeContent').addClass('d-none');
			sound.pause(); // Pause the sound
			sound.currentTime = 0; // Rewind to the beginning
		});
		// #endregion

		// #region Power Curve Tab Sayfası Metodları ve Değişkenleri
		var today = new Date();
		var year = today.getFullYear();
		var month = ('0' + (today.getMonth() + 1)).slice(-2); // Add leading zero if needed
		var day = ('0' + today.getDate()).slice(-2); // Add leading zero if needed
		var datetime = year + '-' + month + '-' + day;
		var selectedPowerCurveOption = 1;
		const powerCurveTabBtn = document.getElementById("PowerCurve-tab");
		const turbineChooseForPowerCurveClose = document.getElementById("TurbineChooseForPowerCurveClose");
		const chooseAllForPowerCurveBtn = document.getElementById("chooseAllForPowerCurveBtn");
		const leaveAllForPowerCurveBtn = document.getElementById("leaveAllForPowerCurveBtn");
		var queryParameterStrForPowerCurve = "";
		let powerCurveTimeOut;
		var selectedTurbineItems = {
		};
		var seriesData = [];
		function setPowerCurveOption(eventSource) {
			if (eventSource == "click") {
				$('#PowerCurveOption').val(1);
				$('#PowerCurveCharts').addClass('d-none');
			}
			selectedPowerCurveOption = document.getElementById('PowerCurveOption').value;
			if (selectedPowerCurveOption == 1) {
				$('#beginDatePowerCurve').attr('type', 'date');
				$("#beginDatePowerCurve").val(datetime);
				$("#endDatePowerCurve").val(datetime);
				$('#EndDatePowerCurveDiv').addClass('d-none');
				$("#BeginDatePowerCurveLabel").html("<b>Günlük Rapor Tarihi</b>");
			}
			else if (selectedPowerCurveOption == 2) {
				$('#EndDatePowerCurveDiv').addClass('d-none');
				$("#BeginDatePowerCurveLabel").html("<b>Aylık Rapor Tarihi</b>");
				$('#beginDatePowerCurve').attr('type', 'month');
				$('#beginDatePowerCurve').val(year + "-" + month);
			}
			else {
				$('#beginDatePowerCurve').attr('type', 'date');
				$("#beginDatePowerCurve").val(datetime);
				$("#endDatePowerCurve").val(datetime);
				$('#EndDatePowerCurveDiv').removeClass('d-none');
				$("#BeginDatePowerCurveLabel").html("<b>Başlangıç Tarihi</b>");
			}
		}

		async function GetDataForPowerCurveTab() {
			let beginDate = $("#beginDatePowerCurve").val();
			let endDate = $("#endDatePowerCurve").val();
			let limitDate = new Date(beginDate);
			limitDate.setDate(limitDate.getDate() + 90);
			// Input validation
			if (selectedPowerCurveOption == 3 && new Date(beginDate) > new Date(endDate)) {
				let modalIcon = '<i class="bi bi-exclamation-square"></i>';
				let modalTitle = "Uyarı: Tarih Seçimi Geçersiz! ";
				let modalBody = "Başlangıç Tarihi Bitiiş Tarihinden Büyük Olamaz!";
				setModalMessage(modalIcon, modalTitle, modalBody);
				return;
			} else if (beginDate == "" || endDate == "") {
				let modalIcon = '<i class="bi bi-exclamation-square"></i>';
				let modalTitle = "Uyarı: Tarih Seçimi Geçersiz! ";
				let modalBody = "Başlangıç Tarihi veya Bitiş Tarihi Boş Olamaz!";
				setModalMessage(modalIcon, modalTitle, modalBody);
				return;
			} else if (selectedTurbineItems.length == 0 || $('#TurbineSelectedTextForPowerCurve').text() == "") {
				let modalIcon = '<i class="bi bi-exclamation-square"></i>';
				let modalTitle = "Uyarı: Parametre Seçimi Geçersiz! ";
				let modalBody = "Lütfen Türbin Seçimini Boş Bırakmayınız!";
				setModalMessage(modalIcon, modalTitle, modalBody);
				return;
			}
			else if ((limitDate < new Date(endDate)) && selectedPowerCurveOption == 3) {
				let modalIcon = '<i class="bi bi-exclamation-square"></i>';
				let modalTitle = "Uyarı: Tarih Seçimi Geçersiz! ";
				let modalBody = "Başlangıç Tarihi ile Bitiş Tarihi Arasında En Fazla 90 Gün Seçimi Yapılabilir!";
				setModalMessage(modalIcon, modalTitle, modalBody);
				return;
			}

			$("#GetDataForPowerCurveTabBtn").text("Seçim Uygulanıyor");
			try {
				const jsonData = await $.ajax({
					type: "GET",
					url: "/Home/GetDataToPowerCurveTab",
					dataType: "json",
					data: {
						"santral": currentSantral,
						"beginDate": beginDate,
						"endDate": endDate,
						"selectedPowerCurveOption": selectedPowerCurveOption,
						"queryParameterStrForPowerCurve": queryParameterStrForPowerCurve
					}
				});

				let message = jsonData.message;

				if (message.startsWith("Hata")) {
					$('#showReturnMessageText').text(message);
					$('#showReturnMessage').removeClass('alert-warning d-none').addClass('alert-danger');
					$('#PowerCurveCharts').addClass('d-none');
				} else if (message.startsWith("Kayıt")) {
					$('#showReturnMessageText').text(message);
					$('#showReturnMessage').removeClass('alert-danger d-none').addClass('alert-warning');
					$('#PowerCurveCharts').addClass('d-none');
				} else {
					$('#showReturnMessage').addClass('d-none');
					$('#PowerCurveCharts').removeClass('d-none');
					$('#PowerWindSpeedCurveFitChart').empty();

					let gotData = jsonData.data;
					let gotCurveFitData = jsonData.curveFitData;
					const contentDivName = document.getElementById('PowerWindSpeedChartofSelectedTurbins');
					$('#PowerWindSpeedChartofSelectedTurbins').empty();


					const chunkSize = 3000;// Her bir türbinin verisi belirlenen chunkSize göre parçalara ayrılır. 
					const delay = 150; //Veriler tamamlanana kadar her belirlenen sn'ye de grafiğe veri doldurma işlemleri yapılır. bu delay onu temsil ediyor.

					//Seçilen her türbin için grafik oluşturmak ve verilerini göstermeyi sağlayan döngü
					for (let j = 0; j < selectedTurbineItems.length; j++) {
						let seriesData = gotData[j].dataList;
						await loadTurbineDataInChunks(j, seriesData, chunkSize, delay, contentDivName);
					}
					//Seçilen tüm türbinleri bir grafik üzerinde üst üste göstermek için oluşturulan metodu çağırıyorum.
					createSingleChartForCurveFitDataList(gotCurveFitData);

				}

			} catch (error) {
				console.error('Error loading data:', error);
				alert("Bir hata oluştu. Lütfen tekrar deneyin.");
			} finally {
				$("#GetDataForPowerCurveTabBtn").text("Seçimi Uygula");
			}
		}
		// Seçilen herbir türbin için ayrı ayrı grafik oluşturuluyor ve verileri parça parça alınıyor.
		async function loadTurbineDataInChunks(j, seriesData, chunkSize, delay, contentDivName) {
			let currentIndex = 0;

			// Create title for the chart
			let newChartTitle = document.createElement('p');
			newChartTitle.classList.add('card-title', 'text-center');
			newChartTitle.innerHTML = selectedTurbineItems[j].userLbl; // Set the title from turbine
			contentDivName.appendChild(newChartTitle);

			// Create a div for the chart
			let newChartDiv = document.createElement('div');
			let chartDivID = selectedTurbineItems[j].id + "PowerWindSpeedChart";
			newChartDiv.id = chartDivID;
			contentDivName.appendChild(newChartDiv);

			// Generate a random color for the chart
			const letters = '0123456789ABCDEF';
			let color = '#';
			for (let i = 0; i < 6; i++) {
				color += letters[Math.floor(Math.random() * 16)];
			}

			// Create the chart instance for this turbine
			let chartInstance = new ej.charts.Chart({
				width: '97%',
				primaryXAxis: {
					title: 'Rüzgar Hızı (m/s)',
					minimum: 0,
					maximum: 27,
					interval: 3,
					labelFormat: '{value} m/s',
				},
				primaryYAxis: {
					title: 'Güç (kW)',
					minimum: -200,
					maximum: 4500,
					interval: 500,
					labelFormat: '{value} kW',
				},
				series: [{
					dataSource: [], // Initially empty, will load chunks
					xName: 'x',
					yName: 'y',
					type: 'Scatter',
					name: selectedTurbineItems[j].userLbl,
					fill: color,
					marker: { visible: true },
				}],
				isResponsive: true,
				tooltip: {
					enable: true,
					format: 'Rüzgar Hızı: ${point.x} <br/> Güç: ${point.y}',
				},
				legendSettings: {
					visible: false,
				},
				animationDuration: 0
			});
			chartInstance.appendTo('#' + chartDivID);

			// Load chunks of data asynchronously
			await loadChunk(seriesData, chunkSize, delay, chartInstance);
		}

		// Her türbinin ayrı ayrı grafiklerde verileri gösterilirken bu metodda veriler parçalanıyor.
		async function loadChunk(seriesData, chunkSize, delay, chartInstance) {
			let currentIndex = 0;

			// Load chunk of data asynchronously
			function processChunk() {
				const chunkData = seriesData.slice(currentIndex, currentIndex + chunkSize);
				chartInstance.series[0].dataSource = chartInstance.series[0].dataSource.concat(chunkData);
				let name = chartInstance.series[0].name;
				// chartInstance.refresh();

				currentIndex += chunkSize;
				// console.log(` ${seriesDataSize} currentIndex ${currentIndex}`);
				if (currentIndex < seriesData.length) {
					setTimeout(processChunk, delay); // Process the next chunk
				}
				else {
					console.log(` ${name}  tamamlandı`);
				}
			}

			// Start loading the chunk
			processChunk();
		}

		// Seçilen tüm türbinlerin tek bir grafik üzerinde gösterilmesi için gerekli kodları içeren method.
		function createSingleChartForCurveFitDataList(allSeriesData) {
			function chunkData(data, chunkSize) {
				const chunks = [];
				for (let i = 0; i < data.length; i += chunkSize) {
					chunks.push(data.slice(i, i + chunkSize));
				}
				return chunks;
			}
			const chunkSize = 1; //Seçilen türbin listesinin başından başlıyarak sonuna kadar her seferinde 1 türbinin verilerini grafiğe eklemek için 1 yaptım. 
			const chunkedData = chunkData(allSeriesData, chunkSize);
			let currentChunkIndex = 0;

			// Tüm türbin verilerinin bir grafikte gösterileceği o grafiği chartInstance oluşturdum.
			let chartInstance = new ej.charts.Chart({
				width: '98%',
				primaryXAxis: {
					title: 'Rüzgar Hızı (m/s)',
					minimum: 0,
					maximum: 27,
					interval: 3,
					labelFormat: '{value} m/s',
				},
				primaryYAxis: {
					title: 'Güç (kW)',
					minimum: -200,
					maximum: 4500,
					interval: 500,
					labelFormat: '{value} kW',
				},
				series: [], // Start with an empty series array
				isResponsive: true,
				tooltip: {
					enable: true,
					format: 'Rüzgar Hızı: ${point.x} <br/> Güç: ${point.y}',
				},
				legendSettings: {
					position: 'Right',
					visible: true,
				},
				animationDuration: 0, // Disable animation for smooth chunk loading
			});

			// Function to load the next chunk of data into the chart
			function loadNextChunk() {
				if (currentChunkIndex < chunkedData.length) {
					const chunk = chunkedData[currentChunkIndex];

					// Map the chunk data to the series and concatenate it with the previous data
					chartInstance.series = [
						...chartInstance.series,  // Keep the previous data
						...chunk.map((data, index) => ({
							type: 'Scatter', // Using Scatter plot for each chunk
							dataSource: data.dataList,
							xName: 'x',
							yName: 'y',
							name: selectedTurbineItems[currentChunkIndex].userLbl, // Name of the turbine or series
						}))
					];
					// Move to the next chunk for the next load
					currentChunkIndex++;

					// Optionally, you can set a delay for loading the next chunk (smooth loading)
					setTimeout(loadNextChunk, 150);  // Adjust the delay for your needs
				} else {
					console.log("CurveFitData loading completed.");
				}
			}

			// Initialize the chart and append it to the container
			chartInstance.appendTo('#AllPowerWindSpeedChartofSelectedTurbins');

			// Start the chunk loading process
			loadNextChunk();
		}

		powerCurveTabBtn.addEventListener("click", function () {
			$('#TurbineSelectedTextForPowerCurve').text('');
			leaveAllForPowerCurveBtn.click();
			setPowerCurveOption("click");
		});
		PowerCurveOption.addEventListener("change", function () {
			setPowerCurveOption("change");
		});
		turbineChooseForPowerCurveClose.addEventListener("click", function () {
			$('#powerCurveModal').modal('hide');
			selectedTurbineItems = $("#TurbineChooseForPowerCurve input[type='checkbox']:checked").map(function () {
				var checkboxId = $(this).attr("id");  // Get the checkbox id
				var lblText = $("label[for='" + checkboxId + "']").text();  // Get the label text for the checkbox
				return { id: checkboxId, userLbl: lblText, powerData: [], windSpeedData: [] };  // Return id, secondChar, and label as an object
			}).get();
			var turbineSelectedTextForPowerCurve = selectedTurbineItems.map(function (item) {
				return item.userLbl;
			});


			$('#TurbineSelectedTextForPowerCurve').html("");
			if (turbineSelectedTextForPowerCurve.length > 0) $('#TurbineSelectedTextForPowerCurve').html("Seçilenler:" + turbineSelectedTextForPowerCurve);
			// query string ayarlanacak
			queryParameterStrForPowerCurve = Object.values(selectedTurbineItems)
				.flat()   // Flatten the arrays (in case there are nested arrays)
				.map(item => item.id)  // Extract the 'id' property from each object
				.filter(item => item !== undefined && item !== null)  // Remove any undefined or null values
				.join(',');  // Join all elements into one string
		});
		chooseAllForPowerCurveBtn.addEventListener("click", function () {
			$('#TurbineChooseForPowerCurve input[type="checkbox"]').prop('checked', true);
		});
		leaveAllForPowerCurveBtn.addEventListener("click", function () {
			$('#TurbineChooseForPowerCurve input[type="checkbox"]').prop('checked', false);
			selectedTurbineItems = {};
		});
		$("#GetDataForPowerCurveTabBtn").on("click", function (event) {
			GetDataForPowerCurveTab();
		});
		// #endregion

		$('#refreshTimeNUD').on('change', function () {
			setIntervalValue();
		});
		$('#DownloadDataByDate').on('click', function () {
			DownloadDataByDate();
		});
		$('#StartStopBtn').on('click', function () {
			StartStopBtnClick();
		});
	}

});

$("#showReturnMessageBtn").on("click", function (event) {
	$('#showReturnMessage').addClass('d-none');
});